Index: palm/trunk/SOURCE/surface_mod.f90
===================================================================
--- palm/trunk/SOURCE/surface_mod.f90	(revision 4501)
+++ palm/trunk/SOURCE/surface_mod.f90	(revision 4502)
@@ -3175,5 +3270,5 @@
                       IF ( ALLOCATED( surf_usm_h%pt_surface ) )                &
                          surf_h(l)%pt_surface(mm(l)) = surf_usm_h%pt_surface(m)
-                      IF ( ALLOCATED( surf_usm_h%q_surface ) )                 &
+                       IF ( ALLOCATED( surf_usm_h%q_surface ) )                &
                          surf_h(l)%q_surface(mm(l)) = surf_usm_h%q_surface(m)
                       IF ( ALLOCATED( surf_usm_h%vpt_surface ) )               &
@@ -3189,10 +3284,10 @@
                       IF ( ALLOCATED( surf_usm_h%ssws ) )                      &
                          surf_h(0)%ssws(mm(0))    = surf_usm_h%ssws(m)
-                      IF ( ALLOCATED( surf_usm_h%css ) )  THEN             
+                      IF ( ALLOCATED( surf_usm_h%css ) )  THEN
                          DO lsp = 1, nvar
                             surf_h(0)%css(lsp,mm(0)) = surf_usm_h%css(lsp,m)
                          ENDDO
                       ENDIF
-                      IF ( ALLOCATED( surf_usm_h%cssws ) )  THEN             
+                      IF ( ALLOCATED( surf_usm_h%cssws ) )  THEN
                          DO lsp = 1, nvar
                             surf_h(0)%cssws(lsp,mm(0)) = surf_usm_h%cssws(lsp,m)
@@ -3201,4 +3296,6 @@
                       IF ( ALLOCATED( surf_usm_h%qcsws ) )                     &
                          surf_h(0)%qcsws(mm(0))   = surf_usm_h%qcsws(m)
+                      IF ( ALLOCATED( surf_usm_h%qisws ) )                     &
+                         surf_h(0)%qisws(mm(0))   = surf_usm_h%qisws(m)
                       IF ( ALLOCATED( surf_usm_h%qrsws ) )                     &
                          surf_h(0)%qrsws(mm(0))   = surf_usm_h%qrsws(m)
@@ -3207,9 +3304,11 @@
                       IF ( ALLOCATED( surf_usm_h%nrsws ) )                     &
                          surf_h(0)%nrsws(mm(0))   = surf_usm_h%nrsws(m)
+                      IF ( ALLOCATED( surf_usm_h%nisws ) )                     &
+                         surf_h(0)%nisws(mm(0))   = surf_usm_h%nisws(m)
                       IF ( ALLOCATED( surf_usm_h%sasws ) )                     &
                         surf_h(0)%sasws(mm(0))   = surf_usm_h%sasws(m)
-                
+
                       mm(0) = mm(0) + 1
-             
+
                    ENDDO
 
@@ -3222,5 +3321,5 @@
 !
 !--       Recalculate start- and end indices for gathered surface type.
-          start_index_h(l) = 1                                        
+          start_index_h(l) = 1
           DO  i = nxl, nxr
              DO  j = nys, nyn
@@ -3252,5 +3351,5 @@
 !--    Treat vertically orientated surface. Again, gather data from different
 !--    surfaces types but identical orientation (e.g. northward-facing) onto
-!--    one surface type which is output afterwards. 
+!--    one surface type which is output afterwards.
        mm(0:3) = 1
        DO  l = 0, 3
@@ -3271,4 +3370,8 @@
                    IF ( ALLOCATED( surf_def_v(l)%ncs ) )                       &
                       surf_v(l)%ncs(mm(l))     = surf_def_v(l)%ncs(m)
+                   IF ( ALLOCATED( surf_def_v(l)%qis ) )                       &
+                      surf_v(l)%qis(mm(l))     = surf_def_v(l)%qis(m)
+                   IF ( ALLOCATED( surf_def_v(l)%nis ) )                       &
+                      surf_v(l)%nis(mm(l))     = surf_def_v(l)%nis(m)
                    IF ( ALLOCATED( surf_def_v(l)%qrs ) )                       &
                       surf_v(l)%qrs(mm(l))     = surf_def_v(l)%qrs(m)
@@ -3291,10 +3394,10 @@
                    IF ( ALLOCATED( surf_def_v(l)%ssws ) )                      &
                       surf_v(l)%ssws(mm(l))    = surf_def_v(l)%ssws(m)
-                   IF ( ALLOCATED( surf_def_v(l)%css ) )  THEN               
+                   IF ( ALLOCATED( surf_def_v(l)%css ) )  THEN
                       DO  lsp = 1, nvar
                          surf_v(l)%css(lsp,mm(l)) = surf_def_v(l)%css(lsp,m)
                       ENDDO
                    ENDIF
-                   IF ( ALLOCATED( surf_def_v(l)%cssws ) )  THEN               
+                   IF ( ALLOCATED( surf_def_v(l)%cssws ) )  THEN
                       DO  lsp = 1, nvar
                          surf_v(l)%cssws(lsp,mm(l)) = surf_def_v(l)%cssws(lsp,m)
@@ -3303,8 +3406,12 @@
                    IF ( ALLOCATED( surf_def_v(l)%qcsws ) )                     &
                       surf_v(l)%qcsws(mm(l))   = surf_def_v(l)%qcsws(m)
+                   IF ( ALLOCATED( surf_def_v(l)%qisws ) )                     &
+                      surf_v(l)%qisws(mm(l))   = surf_def_v(l)%qisws(m)
                    IF ( ALLOCATED( surf_def_v(l)%qrsws ) )                     &
                       surf_v(l)%qrsws(mm(l))   = surf_def_v(l)%qrsws(m)
                    IF ( ALLOCATED( surf_def_v(l)%ncsws ) )                     &
                       surf_v(l)%ncsws(mm(l))   = surf_def_v(l)%ncsws(m)
+                   IF ( ALLOCATED( surf_def_v(l)%nisws ) )                     &
+                      surf_v(l)%nisws(mm(l))   = surf_def_v(l)%nisws(m)
                    IF ( ALLOCATED( surf_def_v(l)%nrsws ) )                     &
                       surf_v(l)%nrsws(mm(l))   = surf_def_v(l)%nrsws(m)
@@ -3317,5 +3424,5 @@
                    IF ( ALLOCATED( surf_def_v(l)%mom_flux_tke) )               &
                       surf_v(l)%mom_flux_tke(0:1,mm(l)) = surf_def_v(l)%mom_flux_tke(0:1,m)
-                
+
                    mm(l) = mm(l) + 1
                 ENDDO
@@ -3335,4 +3442,8 @@
                    IF ( ALLOCATED( surf_lsm_v(l)%ncs ) )                       &
                       surf_v(l)%ncs(mm(l))     = surf_lsm_v(l)%ncs(m)
+                   IF ( ALLOCATED( surf_lsm_v(l)%qis ) )                       &
+                      surf_v(l)%qis(mm(l))     = surf_lsm_v(l)%qis(m)
+                   IF ( ALLOCATED( surf_lsm_v(l)%nis ) )                       &
+                      surf_v(l)%nis(mm(l))     = surf_lsm_v(l)%nis(m)
                    IF ( ALLOCATED( surf_lsm_v(l)%qrs ) )                       &
                       surf_v(l)%qrs(mm(l))     = surf_lsm_v(l)%qrs(m)
@@ -3359,10 +3470,10 @@
                    IF ( ALLOCATED( surf_lsm_v(l)%ssws ) )                      &
                       surf_v(l)%ssws(mm(l))    = surf_lsm_v(l)%ssws(m)
-                   IF ( ALLOCATED( surf_lsm_v(l)%css ) )  THEN              
+                   IF ( ALLOCATED( surf_lsm_v(l)%css ) )  THEN
                       DO  lsp = 1, nvar
                          surf_v(l)%css(lsp,mm(l)) = surf_lsm_v(l)%css(lsp,m)
                       ENDDO
                    ENDIF
-                   IF ( ALLOCATED( surf_lsm_v(l)%cssws ) )  THEN              
+                   IF ( ALLOCATED( surf_lsm_v(l)%cssws ) )  THEN
                       DO  lsp = 1, nvar
                          surf_v(l)%cssws(lsp,mm(l)) = surf_lsm_v(l)%cssws(lsp,m)
@@ -3373,6 +3484,10 @@
                    IF ( ALLOCATED( surf_lsm_v(l)%qrsws ) )                     &
                       surf_v(l)%qrsws(mm(l))   = surf_lsm_v(l)%qrsws(m)
+                   IF ( ALLOCATED( surf_lsm_v(l)%qisws ) )                     &
+                      surf_v(l)%qisws(mm(l))   = surf_lsm_v(l)%qisws(m)
                    IF ( ALLOCATED( surf_lsm_v(l)%ncsws ) )                     &
                       surf_v(l)%ncsws(mm(l))   = surf_lsm_v(l)%ncsws(m)
+                   IF ( ALLOCATED( surf_lsm_v(l)%nisws ) )                     &
+                      surf_v(l)%nisws(mm(l))   = surf_lsm_v(l)%nisws(m)
                    IF ( ALLOCATED( surf_lsm_v(l)%nrsws ) )                     &
                       surf_v(l)%nrsws(mm(l))   = surf_lsm_v(l)%nrsws(m)
@@ -3385,5 +3500,5 @@
                    IF ( ALLOCATED( surf_lsm_v(l)%mom_flux_tke) )               &
                       surf_v(l)%mom_flux_tke(0:1,mm(l)) = surf_lsm_v(l)%mom_flux_tke(0:1,m)
-                
+
                    mm(l) = mm(l) + 1
                 ENDDO
@@ -3403,4 +3518,8 @@
                    IF ( ALLOCATED( surf_usm_v(l)%ncs ) )                       &
                       surf_v(l)%ncs(mm(l))     = surf_usm_v(l)%ncs(m)
+                   IF ( ALLOCATED( surf_usm_v(l)%qis ) )                       &
+                      surf_v(l)%qis(mm(l))     = surf_usm_v(l)%qis(m)
+                   IF ( ALLOCATED( surf_usm_v(l)%nis ) )                       &
+                      surf_v(l)%nis(mm(l))     = surf_usm_v(l)%nis(m)
                    IF ( ALLOCATED( surf_usm_v(l)%qrs ) )                       &
                       surf_v(l)%qrs(mm(l))     = surf_usm_v(l)%qrs(m)
@@ -3427,10 +3546,10 @@
                    IF ( ALLOCATED( surf_usm_v(l)%ssws ) )                      &
                       surf_v(l)%ssws(mm(l))    = surf_usm_v(l)%ssws(m)
-                   IF ( ALLOCATED( surf_usm_v(l)%css ) )  THEN              
+                   IF ( ALLOCATED( surf_usm_v(l)%css ) )  THEN
                       DO  lsp = 1, nvar
                          surf_v(l)%css(lsp,mm(l)) = surf_usm_v(l)%css(lsp,m)
                       ENDDO
                    ENDIF
-                   IF ( ALLOCATED( surf_usm_v(l)%cssws ) )  THEN              
+                   IF ( ALLOCATED( surf_usm_v(l)%cssws ) )  THEN
                       DO  lsp = 1, nvar
                          surf_v(l)%cssws(lsp,mm(l)) = surf_usm_v(l)%cssws(lsp,m)
@@ -3441,6 +3560,10 @@
                    IF ( ALLOCATED( surf_usm_v(l)%qrsws ) )                     &
                       surf_v(l)%qrsws(mm(l))   = surf_usm_v(l)%qrsws(m)
+                   IF ( ALLOCATED( surf_usm_v(l)%qisws ) )                     &
+                      surf_v(l)%qisws(mm(l))   = surf_usm_v(l)%qisws(m)
                    IF ( ALLOCATED( surf_usm_v(l)%ncsws ) )                     &
                       surf_v(l)%ncsws(mm(l))   = surf_usm_v(l)%ncsws(m)
+                   IF ( ALLOCATED( surf_usm_v(l)%nisws ) )                     &
+                      surf_v(l)%nisws(mm(l))   = surf_usm_v(l)%nisws(m)
                    IF ( ALLOCATED( surf_usm_v(l)%nrsws ) )                     &
                       surf_v(l)%nrsws(mm(l))   = surf_usm_v(l)%nrsws(m)
@@ -3453,8 +3576,8 @@
                    IF ( ALLOCATED( surf_usm_v(l)%mom_flux_tke) )               &
                       surf_v(l)%mom_flux_tke(0:1,mm(l)) = surf_usm_v(l)%mom_flux_tke(0:1,m)
-                
+
                    mm(l) = mm(l) + 1
                 ENDDO
-             
+
              ENDDO
           ENDDO
@@ -3544,4 +3667,14 @@
              ENDIF
 
+             IF ( ALLOCATED ( surf_h(l)%qis ) )  THEN
+                CALL wrd_write_string( 'surf_h(' // dum // ')%qis' )
+                WRITE ( 14 )  surf_h(l)%qis
+             ENDIF
+
+             IF ( ALLOCATED ( surf_h(l)%nis ) )  THEN
+                CALL wrd_write_string( 'surf_h(' // dum // ')%nis' )
+                WRITE ( 14 )  surf_h(l)%nis
+             ENDIF
+
              IF ( ALLOCATED ( surf_h(l)%qrs ) )  THEN
                 CALL wrd_write_string( 'surf_h(' // dum // ')%qrs' )
@@ -3624,4 +3757,14 @@
              ENDIF
 
+             IF ( ALLOCATED ( surf_h(l)%qisws ) )  THEN
+                CALL wrd_write_string( 'surf_h(' // dum // ')%qisws' )
+                WRITE ( 14 )  surf_h(l)%qisws
+             ENDIF
+
+             IF ( ALLOCATED ( surf_h(l)%nisws ) )  THEN
+                CALL wrd_write_string( 'surf_h(' // dum // ')%nisws' )
+                WRITE ( 14 )  surf_h(l)%nisws
+             ENDIF
+
              IF ( ALLOCATED ( surf_h(l)%qrsws ) )  THEN
                 CALL wrd_write_string( 'surf_h(' // dum // ')%qrsws' )
@@ -3671,5 +3814,5 @@
                 WRITE ( 14 )  surf_v(l)%ss
              ENDIF
-          
+
              IF ( ALLOCATED ( surf_v(l)%qcs ) )  THEN
                 CALL wrd_write_string( 'surf_v(' // dum // ')%qcs' )
@@ -3682,4 +3825,14 @@
              ENDIF
 
+             IF ( ALLOCATED ( surf_v(l)%qis ) )  THEN
+                CALL wrd_write_string( 'surf_v(' // dum // ')%qis' )
+                WRITE ( 14 )  surf_v(l)%qis
+             ENDIF
+
+             IF ( ALLOCATED ( surf_v(l)%nis ) )  THEN
+                CALL wrd_write_string( 'surf_v(' // dum // ')%nis' )
+                WRITE ( 14 )  surf_v(l)%nis
+             ENDIF
+
              IF ( ALLOCATED ( surf_v(l)%qrs ) )  THEN
                 CALL wrd_write_string( 'surf_v(' // dum // ')%qrs' )
@@ -3706,5 +3859,5 @@
                 WRITE ( 14 )  surf_v(l)%pt_surface
              ENDIF
-          
+
              IF ( ALLOCATED ( surf_v(l)%q_surface ) )  THEN
                 CALL wrd_write_string( 'surf_v(' // dum // ')%q_surface' )
@@ -3750,4 +3903,14 @@
                 CALL wrd_write_string( 'surf_v(' // dum // ')%ncsws' )
                 WRITE ( 14 )  surf_v(l)%ncsws
+             ENDIF
+
+             IF ( ALLOCATED ( surf_v(l)%qisws ) )  THEN
+                CALL wrd_write_string( 'surf_v(' // dum // ')%qisws' )
+                WRITE ( 14 )  surf_v(l)%qisws
+             ENDIF
+
+             IF ( ALLOCATED ( surf_v(l)%nisws ) )  THEN
+                CALL wrd_write_string( 'surf_v(' // dum // ')%nisws' )
+                WRITE ( 14 )  surf_v(l)%nisws
              ENDIF
 
@@ -3830,4 +3993,12 @@
              ENDIF
 
+             IF ( ALLOCATED ( surf_h(l)%qis ) )  THEN
+                CALL wrd_mpi_io_surface( 'surf_h(' // dum // ')%qis', surf_h(l)%qis )
+             ENDIF
+
+             IF ( ALLOCATED ( surf_h(l)%nis ) )  THEN
+                CALL wrd_mpi_io_surface( 'surf_h(' // dum // ')%nis', surf_h(l)%nis )
+             ENDIF
+
              IF ( ALLOCATED ( surf_h(l)%qrs ) )  THEN
                 CALL wrd_mpi_io_surface( 'surf_h(' // dum // ')%qrs', surf_h(l)%qrs )
@@ -3892,4 +4063,12 @@
              IF ( ALLOCATED ( surf_h(l)%ncsws ) )  THEN
                 CALL wrd_mpi_io_surface( 'surf_h(' // dum // ')%ncsws', surf_h(l)%ncsws )
+             ENDIF
+
+             IF ( ALLOCATED ( surf_h(l)%qisws ) )  THEN
+                CALL wrd_mpi_io_surface( 'surf_h(' // dum // ')%qisws', surf_h(l)%qisws )
+             ENDIF
+
+             IF ( ALLOCATED ( surf_h(l)%nisws ) )  THEN
+                CALL wrd_mpi_io_surface( 'surf_h(' // dum // ')%nisws', surf_h(l)%nisws )
              ENDIF
 
@@ -3948,4 +4127,12 @@
              ENDIF
 
+             IF ( ALLOCATED ( surf_v(l)%qis ) )  THEN
+                CALL wrd_mpi_io_surface( 'surf_v(' // dum // ')%qis', surf_v(l)%qis )
+             ENDIF
+
+             IF ( ALLOCATED ( surf_v(l)%nis ) )  THEN
+                CALL wrd_mpi_io_surface( 'surf_v(' // dum // ')%nis', surf_v(l)%nis )
+             ENDIF
+
              IF ( ALLOCATED ( surf_v(l)%qrs ) )  THEN
                 CALL wrd_mpi_io_surface( 'surf_v(' // dum // ')%qrs', surf_v(l)%qrs )
@@ -4002,4 +4189,12 @@
              IF ( ALLOCATED ( surf_v(l)%ncsws ) )  THEN
                 CALL wrd_mpi_io_surface( 'surf_v(' // dum // ')%ncsws', surf_v(l)%ncsws )
+             ENDIF
+
+             IF ( ALLOCATED ( surf_v(l)%qisws ) )  THEN
+                CALL wrd_mpi_io_surface( 'surf_v(' // dum // ')%qisws', surf_v(l)%qisws )
+             ENDIF
+
+             IF ( ALLOCATED ( surf_v(l)%nisws ) )  THEN
+                CALL wrd_mpi_io_surface( 'surf_v(' // dum // ')%nisws', surf_v(l)%nisws )
              ENDIF
 
@@ -4042,10 +4237,10 @@
 ! ------------
 !> Reads surface-related restart data. Please note, restart data for a certain
-!> surface orientation (e.g. horizontal upward-facing) is stored in one 
-!> array, even if surface elements may belong to different surface types 
+!> surface orientation (e.g. horizontal upward-facing) is stored in one
+!> array, even if surface elements may belong to different surface types
 !> natural or urban for example). Surface elements are redistributed into its
-!> respective surface types within this routine. This allows e.g. changing the 
-!> surface type after reading the restart data, which might be required in case 
-!> of cyclic_fill mode. 
+!> respective surface types within this routine. This allows e.g. changing the
+!> surface type after reading the restart data, which might be required in case
+!> of cyclic_fill mode.
 !------------------------------------------------------------------------------!
     SUBROUTINE surface_rrd_local( kk, nxlf, nxlc, nxl_on_file, nxrf,           &
@@ -4064,13 +4259,13 @@
        INTEGER(iwp)       ::  kk          !< running index over previous input files covering current local domain
        INTEGER(iwp)       ::  nxlc        !< index of left boundary on current subdomain
-       INTEGER(iwp)       ::  nxlf        !< index of left boundary on former subdomain 
-       INTEGER(iwp)       ::  nxl_on_file !< index of left boundary on former local domain 
+       INTEGER(iwp)       ::  nxlf        !< index of left boundary on former subdomain
+       INTEGER(iwp)       ::  nxl_on_file !< index of left boundary on former local domain
        INTEGER(iwp)       ::  nxrf        !< index of right boundary on former subdomain
-       INTEGER(iwp)       ::  nxr_on_file !< index of right boundary on former local domain  
+       INTEGER(iwp)       ::  nxr_on_file !< index of right boundary on former local domain
        INTEGER(iwp)       ::  nynf        !< index of north boundary on former subdomain
-       INTEGER(iwp)       ::  nyn_on_file !< index of norht boundary on former local domain  
-       INTEGER(iwp)       ::  nysc        !< index of south boundary on current subdomain 
+       INTEGER(iwp)       ::  nyn_on_file !< index of norht boundary on former local domain
+       INTEGER(iwp)       ::  nysc        !< index of south boundary on current subdomain
        INTEGER(iwp)       ::  nysf        !< index of south boundary on former subdomain
-       INTEGER(iwp)       ::  nys_on_file !< index of south boundary on former local domain  
+       INTEGER(iwp)       ::  nys_on_file !< index of south boundary on former local domain
 
        INTEGER(iwp), SAVE ::  l           !< index variable for surface type
@@ -4093,5 +4288,5 @@
        SELECT CASE ( restart_string(1:length) )
 !
-!--       Read the number of horizontally orientated surface elements and 
+!--       Read the number of horizontally orientated surface elements and
 !--       allocate arrays
           CASE ( 'ns_h_on_file' )
@@ -4100,15 +4295,15 @@
 
                 IF ( ALLOCATED( surf_h(0)%start_index ) )                      &
-                   CALL deallocate_surface_attributes_h( surf_h(0) )           
+                   CALL deallocate_surface_attributes_h( surf_h(0) )
                 IF ( ALLOCATED( surf_h(1)%start_index ) )                      &
-                   CALL deallocate_surface_attributes_h( surf_h(1) )           
+                   CALL deallocate_surface_attributes_h( surf_h(1) )
                 IF ( ALLOCATED( surf_h(2)%start_index ) )                      &
-                   CALL deallocate_surface_attributes_h_top( surf_h(2) )       
-!
-!--             Allocate memory for number of surface elements on file. 
-!--             Please note, these number is not necessarily the same as 
+                   CALL deallocate_surface_attributes_h_top( surf_h(2) )
+!
+!--             Allocate memory for number of surface elements on file.
+!--             Please note, these number is not necessarily the same as
 !--             the final number of surface elements on local domain,
 !--             which is the case if processor topology changes during
-!--             restart runs.  
+!--             restart runs.
 !--             Horizontal upward facing
                 surf_h(0)%ns = ns_h_on_file(0)
@@ -4131,11 +4326,11 @@
 !
 !--             Initial setting of flags for horizontal and vertical surfaces,
-!--             will be set after start- and end-indices are read. 
+!--             will be set after start- and end-indices are read.
                 horizontal_surface = .FALSE.
                 vertical_surface   = .FALSE.
 
-             ENDIF   
-!
-!--       Read the number of vertically orientated surface elements and 
+             ENDIF
+!
+!--       Read the number of vertically orientated surface elements and
 !--       allocate arrays
           CASE ( 'ns_v_on_file' )
@@ -4162,5 +4357,5 @@
                 READ ( 13 )  surf_h(0)%start_index
              l = 0
-          CASE ( 'surf_h(0)%end_index' )   
+          CASE ( 'surf_h(0)%end_index' )
              IF ( kk == 1 )                                                    &
                 READ ( 13 )  surf_h(0)%end_index
@@ -4169,56 +4364,62 @@
 !
 !--       Read specific attributes
-          CASE ( 'surf_h(0)%us' )         
+          CASE ( 'surf_h(0)%us' )
              IF ( ALLOCATED( surf_h(0)%us )  .AND.  kk == 1 )                  &
                 READ ( 13 )  surf_h(0)%us
-          CASE ( 'surf_h(0)%ts' )         
+          CASE ( 'surf_h(0)%ts' )
              IF ( ALLOCATED( surf_h(0)%ts )  .AND.  kk == 1 )                  &
                 READ ( 13 )  surf_h(0)%ts
-          CASE ( 'surf_h(0)%qs' )         
+          CASE ( 'surf_h(0)%qs' )
              IF ( ALLOCATED( surf_h(0)%qs )  .AND.  kk == 1 )                  &
                 READ ( 13 )  surf_h(0)%qs
-          CASE ( 'surf_h(0)%ss' )         
+          CASE ( 'surf_h(0)%ss' )
              IF ( ALLOCATED( surf_h(0)%ss )  .AND.  kk == 1 )                  &
                 READ ( 13 )  surf_h(0)%ss
-          CASE ( 'surf_h(0)%qcs' )         
+          CASE ( 'surf_h(0)%qcs' )
              IF ( ALLOCATED( surf_h(0)%qcs )  .AND.  kk == 1 )                 &
                 READ ( 13 )  surf_h(0)%qcs
-          CASE ( 'surf_h(0)%ncs' )         
+          CASE ( 'surf_h(0)%ncs' )
              IF ( ALLOCATED( surf_h(0)%ncs )  .AND.  kk == 1 )                 &
                 READ ( 13 )  surf_h(0)%ncs
-          CASE ( 'surf_h(0)%qrs' )         
+          CASE ( 'surf_h(0)%qis' )
+             IF ( ALLOCATED( surf_h(0)%qis )  .AND.  kk == 1 )                 &
+                READ ( 13 )  surf_h(0)%qis
+          CASE ( 'surf_h(0)%nis' )
+             IF ( ALLOCATED( surf_h(0)%nis )  .AND.  kk == 1 )                 &
+                READ ( 13 )  surf_h(0)%nis
+          CASE ( 'surf_h(0)%qrs' )
              IF ( ALLOCATED( surf_h(0)%qrs )  .AND.  kk == 1 )                 &
                 READ ( 13 )  surf_h(0)%qrs
-          CASE ( 'surf_h(0)%nrs' )         
+          CASE ( 'surf_h(0)%nrs' )
              IF ( ALLOCATED( surf_h(0)%nrs )  .AND.  kk == 1 )                 &
                 READ ( 13 )  surf_h(0)%nrs
-          CASE ( 'surf_h(0)%ol' )         
+          CASE ( 'surf_h(0)%ol' )
              IF ( ALLOCATED( surf_h(0)%ol )  .AND.  kk == 1 )                  &
                 READ ( 13 )  surf_h(0)%ol
-          CASE ( 'surf_h(0)%rib' )         
+          CASE ( 'surf_h(0)%rib' )
              IF ( ALLOCATED( surf_h(0)%rib )  .AND.  kk == 1 )                 &
                 READ ( 13 )  surf_h(0)%rib
-          CASE ( 'surf_h(0)%pt_surface' )         
+          CASE ( 'surf_h(0)%pt_surface' )
              IF ( ALLOCATED( surf_h(0)%pt_surface )  .AND.  kk == 1 )          &
                 READ ( 13 )  surf_h(0)%pt_surface
-          CASE ( 'surf_h(0)%q_surface' )         
+          CASE ( 'surf_h(0)%q_surface' )
              IF ( ALLOCATED( surf_h(0)%q_surface )  .AND.  kk == 1 )           &
                 READ ( 13 )  surf_h(0)%q_surface
-          CASE ( 'surf_h(0)%vpt_surface' )         
+          CASE ( 'surf_h(0)%vpt_surface' )
              IF ( ALLOCATED( surf_h(0)%vpt_surface )  .AND.  kk == 1 )         &
                 READ ( 13 )  surf_h(0)%vpt_surface
-          CASE ( 'surf_h(0)%usws' )         
+          CASE ( 'surf_h(0)%usws' )
              IF ( ALLOCATED( surf_h(0)%usws )  .AND.  kk == 1 )                &
                 READ ( 13 )  surf_h(0)%usws
-          CASE ( 'surf_h(0)%vsws' )         
+          CASE ( 'surf_h(0)%vsws' )
              IF ( ALLOCATED( surf_h(0)%vsws )  .AND.  kk == 1 )                &
                 READ ( 13 )  surf_h(0)%vsws
-          CASE ( 'surf_h(0)%shf' )         
+          CASE ( 'surf_h(0)%shf' )
              IF ( ALLOCATED( surf_h(0)%shf )  .AND.  kk == 1 )                 &
                 READ ( 13 )  surf_h(0)%shf
-          CASE ( 'surf_h(0)%qsws' )         
+          CASE ( 'surf_h(0)%qsws' )
              IF ( ALLOCATED( surf_h(0)%qsws )  .AND.  kk == 1 )                &
                 READ ( 13 )  surf_h(0)%qsws
-          CASE ( 'surf_h(0)%ssws' )         
+          CASE ( 'surf_h(0)%ssws' )
              IF ( ALLOCATED( surf_h(0)%ssws )  .AND.  kk == 1 )                &
                 READ ( 13 )  surf_h(0)%ssws
@@ -4226,82 +4427,94 @@
              IF ( ALLOCATED( surf_h(0)%css )  .AND.  kk == 1 )                 &
                 READ ( 13 )  surf_h(0)%css
-          CASE ( 'surf_h(0)%cssws' )         
+          CASE ( 'surf_h(0)%cssws' )
              IF ( ALLOCATED( surf_h(0)%cssws )  .AND.  kk == 1 )               &
                 READ ( 13 )  surf_h(0)%cssws
-          CASE ( 'surf_h(0)%qcsws' )         
+          CASE ( 'surf_h(0)%qcsws' )
              IF ( ALLOCATED( surf_h(0)%qcsws )  .AND.  kk == 1 )               &
                 READ ( 13 )  surf_h(0)%qcsws
-          CASE ( 'surf_h(0)%ncsws' )         
+          CASE ( 'surf_h(0)%ncsws' )
              IF ( ALLOCATED( surf_h(0)%ncsws )  .AND.  kk == 1 )               &
                 READ ( 13 )  surf_h(0)%ncsws
-          CASE ( 'surf_h(0)%qrsws' )         
+          CASE ( 'surf_h(0)%qisws' )
+             IF ( ALLOCATED( surf_h(0)%qisws )  .AND.  kk == 1 )               &
+                READ ( 13 )  surf_h(0)%qisws
+          CASE ( 'surf_h(0)%nisws' )
+             IF ( ALLOCATED( surf_h(0)%nisws )  .AND.  kk == 1 )               &
+                READ ( 13 )  surf_h(0)%nisws
+          CASE ( 'surf_h(0)%qrsws' )
              IF ( ALLOCATED( surf_h(0)%qrsws )  .AND.  kk == 1 )               &
                 READ ( 13 )  surf_h(0)%qrsws
-          CASE ( 'surf_h(0)%nrsws' )         
+          CASE ( 'surf_h(0)%nrsws' )
              IF ( ALLOCATED( surf_h(0)%nrsws )  .AND.  kk == 1 )               &
                 READ ( 13 )  surf_h(0)%nrsws
-          CASE ( 'surf_h(0)%sasws' )         
+          CASE ( 'surf_h(0)%sasws' )
              IF ( ALLOCATED( surf_h(0)%sasws )  .AND.  kk == 1 )               &
                 READ ( 13 )  surf_h(0)%sasws
 
-          CASE ( 'surf_h(1)%start_index' )   
+          CASE ( 'surf_h(1)%start_index' )
              IF ( kk == 1 )                                                    &
                 READ ( 13 )  surf_h(1)%start_index
              l = 1
-          CASE ( 'surf_h(1)%end_index' )   
+          CASE ( 'surf_h(1)%end_index' )
              IF ( kk == 1 )                                                    &
                 READ ( 13 )  surf_h(1)%end_index
-          CASE ( 'surf_h(1)%us' )         
+          CASE ( 'surf_h(1)%us' )
              IF ( ALLOCATED( surf_h(1)%us )  .AND.  kk == 1 )                  &
                 READ ( 13 )  surf_h(1)%us
-          CASE ( 'surf_h(1)%ts' )         
+          CASE ( 'surf_h(1)%ts' )
              IF ( ALLOCATED( surf_h(1)%ts )  .AND.  kk == 1 )                  &
                 READ ( 13 )  surf_h(1)%ts
-          CASE ( 'surf_h(1)%qs' )         
+          CASE ( 'surf_h(1)%qs' )
              IF ( ALLOCATED( surf_h(1)%qs )  .AND.  kk == 1 )                  &
                 READ ( 13 )  surf_h(1)%qs
-          CASE ( 'surf_h(1)%ss' )         
+          CASE ( 'surf_h(1)%ss' )
              IF ( ALLOCATED( surf_h(1)%ss )  .AND.  kk == 1 )                  &
                 READ ( 13 )  surf_h(1)%ss
-          CASE ( 'surf_h(1)%qcs' )         
+          CASE ( 'surf_h(1)%qcs' )
              IF ( ALLOCATED( surf_h(1)%qcs )  .AND.  kk == 1 )                 &
                 READ ( 13 )  surf_h(1)%qcs
-          CASE ( 'surf_h(1)%ncs' )         
+          CASE ( 'surf_h(1)%ncs' )
              IF ( ALLOCATED( surf_h(1)%ncs )  .AND.  kk == 1 )                 &
                 READ ( 13 )  surf_h(1)%ncs
-          CASE ( 'surf_h(1)%qrs' )         
+          CASE ( 'surf_h(1)%qis' )
+             IF ( ALLOCATED( surf_h(1)%qis )  .AND.  kk == 1 )                 &
+                READ ( 13 )  surf_h(1)%qis
+          CASE ( 'surf_h(1)%nis' )
+             IF ( ALLOCATED( surf_h(1)%nis )  .AND.  kk == 1 )                 &
+                READ ( 13 )  surf_h(1)%nis
+          CASE ( 'surf_h(1)%qrs' )
              IF ( ALLOCATED( surf_h(1)%qrs )  .AND.  kk == 1 )                 &
                 READ ( 13 )  surf_h(1)%qrs
-          CASE ( 'surf_h(1)%nrs' )         
+          CASE ( 'surf_h(1)%nrs' )
              IF ( ALLOCATED( surf_h(1)%nrs )  .AND.  kk == 1 )                 &
                 READ ( 13 )  surf_h(1)%nrs
-          CASE ( 'surf_h(1)%ol' )         
+          CASE ( 'surf_h(1)%ol' )
              IF ( ALLOCATED( surf_h(1)%ol )  .AND.  kk == 1 )                  &
                 READ ( 13 )  surf_h(1)%ol
-          CASE ( 'surf_h(1)%rib' )         
+          CASE ( 'surf_h(1)%rib' )
              IF ( ALLOCATED( surf_h(1)%rib )  .AND.  kk == 1 )                 &
                 READ ( 13 )  surf_h(1)%rib
-          CASE ( 'surf_h(1)%pt_surface' )         
+          CASE ( 'surf_h(1)%pt_surface' )
              IF ( ALLOCATED( surf_h(1)%pt_surface )  .AND.  kk == 1 )          &
                 READ ( 13 )  surf_h(1)%pt_surface
-          CASE ( 'surf_h(1)%q_surface' )         
+          CASE ( 'surf_h(1)%q_surface' )
              IF ( ALLOCATED( surf_h(1)%q_surface )  .AND.  kk == 1 )           &
                 READ ( 13 )  surf_h(1)%q_surface
-          CASE ( 'surf_h(1)%vpt_surface' )         
+          CASE ( 'surf_h(1)%vpt_surface' )
              IF ( ALLOCATED( surf_h(1)%vpt_surface )  .AND.  kk == 1 )         &
                 READ ( 13 )  surf_h(1)%vpt_surface
-          CASE ( 'surf_h(1)%usws' )         
+          CASE ( 'surf_h(1)%usws' )
              IF ( ALLOCATED( surf_h(1)%usws )  .AND.  kk == 1 )                &
                 READ ( 13 )  surf_h(1)%usws
-          CASE ( 'surf_h(1)%vsws' )         
+          CASE ( 'surf_h(1)%vsws' )
              IF ( ALLOCATED( surf_h(1)%vsws )  .AND.  kk == 1 )                &
                 READ ( 13 )  surf_h(1)%vsws
-          CASE ( 'surf_h(1)%shf' )         
+          CASE ( 'surf_h(1)%shf' )
              IF ( ALLOCATED( surf_h(1)%shf )  .AND.  kk == 1 )                 &
                 READ ( 13 )  surf_h(1)%shf
-          CASE ( 'surf_h(1)%qsws' )         
+          CASE ( 'surf_h(1)%qsws' )
              IF ( ALLOCATED( surf_h(1)%qsws )  .AND.  kk == 1 )                &
                 READ ( 13 )  surf_h(1)%qsws
-          CASE ( 'surf_h(1)%ssws' )         
+          CASE ( 'surf_h(1)%ssws' )
              IF ( ALLOCATED( surf_h(1)%ssws )  .AND.  kk == 1 )                &
                 READ ( 13 )  surf_h(1)%ssws
